c=======================================================================
c***********************************************************************
      subroutine lai_limit_w_monthly
c***********************************************************************
c=======================================================================
      implicit none
c=======================================================================
c     This routine calculates monthly lai limits to assure coherence
c     between CARAIB and IBM
c=======================================================================

      include './com_18/annee.common'
      include './com_18/parameter.common'
      include './com_18/bagnum.common'
      include './com_18/climin0.common'
      include './com_18/ecoin.common'
      include './com_18/laih2o.common'
      include './com_18/laiste.common'
      include './com_18/loop.common'
      include './com_18/monthcst.common'
      include './com_18/monwat.common'
      include './com_18/pho_sch.common'
      include './com_18/pnpp2.common'
      include './com_18/strate.common'
      include './com_18/tresh.common'
      include './com_18/xvalues.common'
c-----------------------------------------------
c JLP ajouté pour implicit none
c
      integer m,day,n
      real*4 corr_wat,etrmax,fh2o_mth,tmin0,wgt_yvs,xlai_mth
      
c-----------------------------------------------

      dimension fh2o_mth(nm),xlai_mth(nm)

       if(frac(ip).gt.1.e-7) then
  
cIngrid201804
          m = imonth(iday)
	  n=m+1
          fh2o_mth(m) = 0.
          xlai_mth(m) = 0.
        do day = ini(m),ifin(m)
          fh2o_mth(m) = fh2o_mth(m) + zfh2o(ip,day) * xlai(ip,day)
          xlai_mth(m) = xlai_mth(m) + xlai(ip,day)
        enddo	
          cfh2o(ip,m) = fh2o_mth(m)
          xlai_mth(m) = xlai_mth(m) / float(mlength(m))
cIngrid201804


cIngrid201804
c        ylai_w(ip) = 0.
        wgt_yvs = 0.
        yvslai_w(ip) = 0. 
cIngrid201804
c        yminlai_w(ip) = xlaimax


c rtrcar(m) = fraction of evaporation svecar(m) associated with 
c          vegetation transpiration
c-----------------------------------------------------------------------

cIngrid201804
c        do m = 1, nm
          xlai_w(ip,m) = xlaimax        
          etrmax = rtrcar(m) * svecar(m)
          if(etrmax.lt.0.) etrmax = 0.

cc------------------A CHANGER----------------------------------------
          if(cfh2o(ip,m).gt.0. .and. cfh2o(ip,m).gt.etrmax) then
             corr_wat = etrmax/cfh2o(ip,m)
CV8              if(nyr_t.eq.0) corr_wat = (1.+ (etrmax/cfh2o(ip,m)))/2.
             xlai_w(ip,m) = xlai_mth(m)*corr_wat
	     xlai_w(ip,n)=xlai_w(ip,m)
          endif
cc-----------------A CHANGER------------------------------------------

          if (xlai_w(ip,m).le.0.) then
	    xlai_w(ip,m) = 0.
          endif
          ylai_w(ip) = ylai_w(ip)+xlai_w(ip,m)
     &               * float(mlength(m))/float(nd) 

c          if (fsncar(m).lt.0.1) then
c            if (idec(ip).eq.0) then 
c              wgt_yvs = wgt_yvs+float(mlength(m))/float(nd)
c              yvslai_w(ip) = yvslai_w(ip)+xlai_w(ip,m)
c     &             * float(mlength(m))/float(nd)
c              if(yminlai_w(ip).ge.xlai_w(ip,m))then
c                yminlai_w(ip)=xlai_w(ip,m)
c              endif
c            elseif (idec(ip).eq.1) then
c              tmin0 = tcel0(m)-tdiff0(m)/2.
c              if (tmin0.gt.ttreshi1(ip)) then
c                wgt_yvs = wgt_yvs+float(mlength(m))/float(nd)
c                yvslai_w(ip) = yvslai_w(ip)+xlai_w(ip,m)
c     &                      * float(mlength(m))/float(nd)
c                if(yminlai_w(ip).ge.xlai_w(ip,m))then
c                  yminlai_w(ip)=xlai_w(ip,m)
c                endif
c              endif
c            elseif (idec(ip).eq.2) then 
c              if (swcar(m).gt.wattresh1(ip)) then
c                wgt_yvs = wgt_yvs+float(mlength(m))/float(nd)
c                yvslai_w(ip) = yvslai_w(ip)+xlai_w(ip,m)
c     &               * float(mlength(m))/float(nd)
c                if(yminlai_w(ip).ge.xlai_w(ip,m))then
c                  yminlai_w(ip)=xlai_w(ip,m)
c                endif
c              endif
c            endif
c          endif
cIngrid201804
c boucle sur les mois
c      enddo

	 
c        if (wgt_yvs.gt.1.e-5) then
c          yvslai_w(ip) = yvslai_w(ip)/wgt_yvs
c        else
c          yvslai_w(ip) = 0.
c        endif
	
c if sur frac
       endif

cIngrid201804
c boucle sur les ip
c      enddo

      return 
      end subroutine lai_limit_w_monthly