c=======================================================================
c***********************************************************************
      subroutine mortality(ngt)
c***********************************************************************
c======================================================================= 
      implicit none
      
      include './com_18/parameter.common' 
      include './com_18/ageclas.common'
      include './com_18/annppf.common'
      include './com_18/burned.common'
      include './com_18/coord.common'
      include './com_18/cte.common'
      include './com_18/cstmort.common'
      include './com_18/ecoin.common'
      include './com_18/ext_con2.common'
      include './com_18/mort.common'
      include './com_18/gk.common'
      include './com_18/inidata.common'
      include './com_18/litiere.common'
      include './com_18/npp.common'
      include './com_18/nspc.common'
      include './com_18/plant_pool.common'
      include './com_18/prev_yr.common'      
      include './com_18/soil_marie.common'
      include './com_18/tresh.common'     

c-----------------------------------------------
c JLP ajouté pour implicit none
c
      integer , intent(in) :: ngt
      
      integer iday,iday2,ip,ipool
      
c-----------------------------------------------      

      
      
      real*4  ftmin_tempo(npft),fwat_tempo(npft),fnat_tempo(npft) 
      real*4 gkfall_tree,vigor  
      
c=======================================================================
c     loss fraction
c======================================================================= 
 
      do ip = 1, npft
      
       ftot(ip) = 1.
       ftmin(ip) = 1.
       fwat(ip) = 1.
       fnat(ip) = 1.
       ftmin_tempo(ip) = 1.
       fwat_tempo(ip) = 1.
       fnat_tempo(ip) = 1.

       if (frac(ip).gt.1.e-7) then
         
        tmin_inf(ip) = ttreshi2(ip) - delta_tmin
        tmin_sup(ip) = ttreshi2(ip) + delta_tmin
        
        wat_inf(ip) = wattresh2(ip) * (1. - delta_watmin)
        wat_sup(ip) = wattresh2(ip) * (1. + delta_watmin)
	
        if ((ilgtree.eq.1).and.
     &   ((ip.ge.nherb+nbush+1).and.(ip.le.npft0))) then
         if (xlaimax_prv(ip).ge.0.1) then
	  vigor = max(0.,ybinc_prv(ip)/xlaimax_prv(ip))
	 else
	  vigor = 0.
	 endif
	 gkfall_tree = 0.000274/(1.+0.035*vigor) 
         fnat(ip) = 1. - gkfall_tree
	 
         write(61,'(2(1x,f8.3),1x,i2,5(1x,e12.5))')ylongi,ylati,ip
     & ,ybinc_prv(ip),xlaimax_prv(ip),vigor,gkfall_tree,fnat(ip)
	
        else
c         fnat(ip) = 1. - 1. / (365.*icyear_mean(ip,nclas(ip)))
         fnat(ip) = 1. - 1. / (365.*icyear_max(ip,nclas(ip)))
CXC     &                - gk_fall(ip,2,1)

        endif
	


        ftemp(ip,nd) = 1.

        do iday = 1, nd 
        
          iday2 = iday - 1
          if(iday.eq.1) iday2 = nd
      
          if ((ilgtree.eq.1).and.
     &     ((ip.ge.nherb+nbush+1).and.(ip.le.npft0))) then
             ftmin(ip) = 1.
	     fwat(ip) = 1.
          else	        
             ftmin(ip) = 1.-gk_fall(ip,2,3)+gk_fall(ip,2,3)*
     &       (0.5*(1.+erf(xk_erf*(tmin2(iday)-ttreshi2(ip))/
     &                   delta_tmin))) 
             fwat(ip) = 1.-gk_fall(ip,2,2)+gk_fall(ip,2,2)*
     &       (0.5*(1.+erf(xk_erf*(water2(iday)-wattresh2(ip))/
     &                   (delta_watmin*wattresh2(ip)))))                   
          endif

          if(ftmin(ip).lt.0. .or. ftmin(ip).gt.1.000001) then
              write(61,*) 'errrrrrror',ftmin(ip)
          endif
          
          ftot(ip) = ftot(ip)*ftmin(ip)*fwat(ip)*fnat(ip)
          
          ftmin_tempo(ip) = ftmin_tempo(ip)*ftmin(ip)
          fwat_tempo(ip) = fwat_tempo(ip)*fwat(ip)
          fnat_tempo(ip) = fnat_tempo(ip)*fnat(ip)
          
          if(iday.eq.nd) then
            ftmin(ip) = ftmin_tempo(ip)
            fwat(ip) = fwat_tempo(ip)
            fnat(ip) = fnat_tempo(ip)
          endif
          
          ftemp(ip,iday) = ftot(ip)
          
c=======================================================================
c     litter production
c=======================================================================   
                  
          do ipool = 1, npool
            if(iday.eq.1) then
              xlit_newprod(ip,ipool,iday) = (1.-ftemp(ip,iday))
     &                             *ycar_ini(ip,ipool,ngt)
             else
               xlit_newprod(ip,ipool,iday) = (ftemp(ip,iday2)
     &                  -ftemp(ip,iday))*carbon(ip,ipool,iday2)
               xlit_prod(ip,ipool,iday) = xlit_prod(ip,ipool,iday)
     &                                  + xlit_newprod(ip,ipool,iday)
             endif
                    
          enddo

        enddo
       endif            
       
       ftot(ip) = ftot(ip) * yfnoburn
      enddo
        
      return
      end subroutine mortality