c=======================================================================
c***********************************************************************
      subroutine wri_res
c***********************************************************************
c=======================================================================
      implicit none
c=======================================================================
c   This routine write results.
c=======================================================================

      include './com_18/parameter.common'
      include './com_18/abobio.common'      
      include './com_18/angppf.common'
      include './com_18/annee.common'
      include './com_18/annppf.common'
      include './com_18/biomasse.common'
      include './com_18/burned.common'      
      include './com_18/cmoiRmin.common'      
      include './com_18/coord.common'
      include './com_18/crops.common'      
      include './com_18/cte.common'
      include './com_18/dayres.common'
      include './com_18/ecoin.common'
      include './com_18/fire_emi.common'      
      include './com_18/fracc13.common'
      include './com_18/frac_change.common'      
      include './com_18/gddpix.common'
      include './com_18/gridin2.common'
      include './com_18/iprt.common'
      include './com_18/loop.common'
      include './com_18/nspc.common'
      include './com_18/management.common'      
      include './com_18/monres.common'
      include './com_18/monthcst.common'
      include './com_18/monthcst2.common'
      include './com_18/mort.common'      
      include './com_18/plant_pool.common'
      include './com_18/plant_evol.common'      
      include './com_18/prt_ctrl.common'
      include './com_18/pzone.common'
      include './com_18/soil_pool.common'
      include './com_18/xvalues.common'


      character*100 formatw
c-----------------------------------------------
c JLP ajouté pour implicit none
c
    
      integer m,kpool

c-----------------------------------------------        
CC      real*4 tempo1(npft),tempo2(npft),tempo3(npft),tempo4,tempo5(npft)
CC     &       ,tempo6(npft),tempo7(npft),tempo8(npft)
      real*4 ylitr 

c=======================================================================
c   write annual and monthly results.
c       ynpp     = yearly npp;
c       ygpp     = yearly leaf gpp;
c       xmnpp    = monthly npp;
c       xmnep    = monthly nep;
c       xmlai    = monthly mean leaf area index.
c       xmbiom   = monthly mean total biomass
c=======================================================================

      do ip = 1, npft
        yraf(ip) = ygppf(ip) - ynppf(ip)
      end do

      do iday = 1, nd
        xdra(iday) = xdgpp(iday) - xdnpp(iday)
	xdrh(iday) = xdnpp(iday) - xdnep(iday)
        xdemifire(iday) = emi_burn_lit(iday)
	do ip = 1, npft
	 xra(ip,iday) = xgpp(ip,iday) - xnpp(ip,iday)
	 xdemifire(iday) = xdemifire(iday)+frac(ip)*xemifire(ip,iday)
	 xdcharvest(iday)= xdcharvest(iday)+frac(ip)*xcharvest(ip,iday)	 
	end do
	xdnbp(iday) = xdnep(iday) - xdemifire(iday) - xdcharvest(iday)
      end do

      do iday = 1, nd
        m = imonth(iday)
        xmnpp(m) = xmnpp(m) + xdnpp(iday)
        xmgpp(m) = xmgpp(m) + xdgpp(iday)
	xmra(m) = xmra(m) + xdra(iday)
	xmrh(m) = xmrh(m) + xdrh(iday)
        xmnep(m) = xmnep(m) + xdnep(iday)
	xmnbp(m) = xmnbp(m) + xdnbp(iday)
	xmemifire(m) = xmemifire(m) + xdemifire(iday)
	xmcharvest(m) = xmcharvest(m) + xdcharvest(iday)
	xmemiblit(m) = xmemiblit(m) + emi_burn_lit(iday)
        xmlai(m) = xmlai(m) + xdlai(iday)
        xmbiom(m) = xmbiom(m) + xdbiom(iday)
        xmPnf(m) = xmPnf(m) * (1.-Pf(iday))
        xmfapar(m) = xmfapar(m) + xdfapar(iday)
        xmfrac_burn(m) = xmfrac_burn(m) + frac_burn(iday)
        xmarea_burn(m) = xmarea_burn(m) + area_burn(iday)
      enddo

      do m = 1, nm
        xmnpp(m) = xmnpp(m) * xmfac(m) 
        xmgpp(m) = xmgpp(m) * xmfac(m)
	    xmra(m) = xmra(m) * xmfac(m)
	    xmrh(m) = xmrh(m) * xmfac(m)
        xmnep(m) = xmnep(m) * xmfac(m)
	    xmnbp(m) = xmnbp(m) * xmfac(m)
	    xmemifire(m) = xmemifire(m) * xmfac(m)
	    xmcharvest(m) = xmcharvest(m) * xmfac(m)
	    xmemiblit(m) = xmemiblit(m) * xmfac(m)
        xmlai(m) = xmlai(m) / float(mlength(m))
        xmfapar(m) = xmfapar(m) / float(mlength(m))
        xmbiom(m) = xmbiom(m) / float(mlength(m))
        xmfrac_burn(m) = xmfrac_burn(m) * xmfac(m)
        xmarea_burn(m) = xmarea_burn(m) * xmfac(m)
        xmPf(m) = 1. - xmPnf(m) 
      enddo

c       if ((ifrac.eq.1.and.imig.eq.0).or.   
c     &     (ifrac.eq.1.and.imig.eq.1.and.nyr_t.eq.0)) then  ! marie
c       if (ifrac.eq.1) then
        write(formatw,*)'(f8.3,1x,f8.3,',npft,'(1x,f10.8))'
        if(iprt_frac.eq.1)
     &    write(60,formatw) ylongi,ylati,(frac(ip),ip=1,npft)
c       endif
       
       write(formatw,*)'(2(f8.3,1x),',2*npft,'(f5.2,1x))'       
       if(iprt_laimin.eq.1)
     &    write(64,formatw) ylongi,ylati,(xlai_min(ip),ip=1,npft)
     &                     ,(xlai_max(ip),ip=1,npft)       
             
c beginning of if statement on iyprt
      if (iyprt.ge.1) then
      
       if (idaily_out.eq.0) then
        write(formatw,*)'(f8.3,1x,f8.3,',nm,'(1x,f11.2))'
        if(iprt_biomm.eq.1)
     &    write(55,formatw)ylongi,ylati,(xmbiom(m),m=1,nm)
        if(iprt_gppm.eq.1) 
     &    write(56,formatw)ylongi,ylati,(xmgpp(m),m=1,nm)
        if(iprt_ram.eq.1) 
     &    write(556,formatw)ylongi,ylati,(xmra(m),m=1,nm)     
        if(iprt_nppm.eq.1)
     &    write(57,formatw)ylongi,ylati,(xmnpp(m),m=1,nm)
        if(iprt_nepm.eq.1)
     &    write(58,formatw)ylongi,ylati,(xmnep(m),m=1,nm)
        if(iprt_rhm.eq.1) 
     &    write(558,formatw)ylongi,ylati,(xmrh(m),m=1,nm)     
        if(iprt_laim.eq.1)
     &    write(59,formatw)ylongi,ylati,(xmlai(m),m=1,nm)
        if(iprt_emifirem.eq.1)
     &    write(559,formatw)ylongi,ylati,(xmemifire(m),m=1,nm)
        if(iprt_emiblitm.eq.1)
     &    write(560,formatw)ylongi,ylati,(xmemiblit(m),m=1,nm)     
        if(iprt_nbpm.eq.1)
     &    write(561,formatw)ylongi,ylati,(xmnbp(m),m=1,nm)
        if ((imanag.eq.1).or.(ncrop.gt.0)) then
	 if(iprt_harvm.eq.1)
     &     write(562,formatw)ylongi,ylati,(xmcharvest(m),m=1,nm)
	endif               
        write(formatw,*)'(f8.3,1x,f8.3,',nm,'(1x,f6.3))'
        if(iprt_faparm.eq.1)
     &    write(98,formatw)ylongi,ylati,(xmfapar(m),m=1,nm)
       else
        write(formatw,*)'(f8.3,1x,f8.3,',nd,'(1x,f11.2))'
        if(iprt_biomm.eq.1)
     &    write(55,formatw)ylongi,ylati,(xdbiom(iday),iday=1,nd)        
        if(iprt_gppm.eq.1) 
     &    write(56,formatw)ylongi,ylati,(xdgpp(iday),iday=1,nd)
        if(iprt_ram.eq.1) 
     &    write(556,formatw)ylongi,ylati,(xdra(iday),iday=1,nd)     
        if(iprt_nppm.eq.1)
     &    write(57,formatw)ylongi,ylati,(xdnpp(iday),iday=1,nd)
        if(iprt_nepm.eq.1)
     &    write(58,formatw)ylongi,ylati,(xdnep(iday),iday=1,nd)
        if(iprt_rhm.eq.1) 
     &    write(558,formatw)ylongi,ylati,(xdrh(iday),iday=1,nd)     
        if(iprt_laim.eq.1)
     &    write(59,formatw)ylongi,ylati,(xdlai(iday),iday=1,nd)
        if(iprt_emifirem.eq.1)
     &    write(559,formatw)ylongi,ylati,(xdemifire(iday),iday=1,nd)
        if(iprt_emiblitm.eq.1)
     &    write(560,formatw)ylongi,ylati,(emi_burn_lit(iday),iday=1,nd)     
        if(iprt_nbpm.eq.1)
     &    write(561,formatw)ylongi,ylati,(xdnbp(iday),iday=1,nd)
        if ((imanag.eq.1).or.(ncrop.gt.0)) then
	 if(iprt_harvm.eq.1)
     &     write(562,formatw)ylongi,ylati,(xdcharvest(iday),iday=1,nd)
	endif     		       
       endif
       if (iyprt.eq.1) then
         write(formatw,*)'(f8.3,1x,f8.3,',npft,'(1x,f11.2))'
         if(iprt_nppf.eq.1)
     &    write(62,formatw) ylongi,ylati,(ynppf(ip),ip=1,npft)
         if(iprt_gpp.eq.1)
     &    write(65,formatw) ylongi,ylati,(ygppf(ip),ip=1,npft)
         if(iprt_raf.eq.1)
     &    write(565,formatw) ylongi,ylati,(yraf(ip),ip=1,npft)
         if(iprt_emifiref.eq.1)
     &    write(665,formatw) ylongi,ylati,(yemifiref(ip),ip=1,npft)               
         elseif (iyprt.eq.2) then
          write(formatw,*)'(',nd,'(1x,f6.2))'
	      if(iprt_nppf.eq.1) then
            write(62,'(f8.3,1x,f8.3)') ylongi,ylati
	      do ip = 1, npft
            write(62,formatw) (xnpp(ip,iday),iday=1,nd)
	      end do
	     endif	  
	     if(iprt_gpp.eq.1) then
          write(65,'(f8.3,1x,f8.3)') ylongi,ylati
          do ip = 1, npft
	       write(65,formatw) (xgpp(ip,iday),iday=1,nd)
	      end do
	     endif
	     if(iprt_raf.eq.1) then
          write(565,'(f8.3,1x,f8.3)') ylongi,ylati
	      do ip = 1, npft
	        write(565,formatw) (xra(ip,iday),iday=1,nd)
	      end do
	     endif
         if(iprt_emifiref.eq.1) then
          write(665,'(f8.3,1x,f8.3)') ylongi,ylati
	      do ip = 1, npft
	        write(665,formatw) (xemifire(ip,iday),iday=1,nd)
	      end do
	     endif			   
      endif
       
       write(formatw,*)'(f8.3,1x,f8.3,',npft,'(1x,f11.2))'
       if(iprt_Cveg.eq.1)
     &    write(66,formatw) ylongi,ylati,(ybiomf(ip),ip=1,npft)
       if(iprt_Csoil.eq.1) then
          ylitr=ysoilr(1)+ysoilr(2)
          write(67,6767) ylongi,ylati,ysoilr(0),ylitr
     &                  ,(ysoilr(kpool),kpool=1,3)
       endif
 6767  format(f8.3,1x,f8.3,5(1x,f11.2))
       if(iprt_frcC13.eq.1)
     &    write(68,formatw) ylongi,ylati,(yfractf(ip),ip=1,npft)
       write(formatw,*)'(2(f8.3,1x),',npft,'(f9.2,1x))'
       if(iprt_Rmin.eq.1)
     &    write(63,formatw) ylongi,ylati,(R_min(ip),ip=1,npft)
     
       if (iyprt.eq.1) then
        write(formatw,*)'(f8.3,1x,f8.3,',npft,'(1x,f6.3))'
        if(iprt_laimoy.eq.1)  
     &    write(69,formatw) ylongi,ylati,(xlai_moy(ip),ip=1,npft)
       elseif (iyprt.eq.2) then
        write(formatw,*)'(',nd,'(1x,f6.3))'
	write(69,'(f8.3,1x,f8.3)') ylongi,ylati
	do ip = 1, npft
	 write(69,formatw) (xlai(ip,iday),iday=1,nd)
	end do
       endif
        

       if (ifire.eq.1) then
        if (idaily_out.eq.0) then
c monthly results of fire module
         write(formatw,*)'(f8.3,1x,f8.3,',nm,'(1x,1pe9.2))'
         if(iprt_fire.eq.1) 
     &     write(73,formatw)ylongi,ylati,(xmPf(m),m=1,nm)
         if(iprt_fburn.eq.1)
     &     write(74,formatw)ylongi,ylati,(xmfrac_burn(m),m=1,nm)
         if(iprt_aburn.eq.1)
     &     write(75,formatw)ylongi,ylati,(xmarea_burn(m),m=1,nm)
        else
c daily results of fire module
         write(formatw,*)'(f8.3,1x,f8.3,',nd,'(1x,1pe9.2))'
         if(iprt_fire.eq.1) 
     &     write(73,formatw)ylongi,ylati,(Pf(iday),iday=1,nd)
         if(iprt_fburn.eq.1)
     &     write(74,formatw)ylongi,ylati,(frac_burn(iday),iday=1,nd)
         if(iprt_aburn.eq.1)
     &     write(75,formatw)ylongi,ylati,(area_burn(iday),iday=1,nd)    
        endif           
       endif
       
       if ((imanag.eq.1).or.(ncrop.gt.0)) then
        write(formatw,*)'(f8.3,1x,f8.3,',npft,'(1x,f11.2))'      
        if(iprt_harv.eq.1)
     &     write(79,formatw)ylongi,ylati,(ycharvest(ip),ip=1,npft)
       endif       
       if (ncrop.gt.0) then
        write(formatw,*)'(f8.3,1x,f8.3,',npft,'(1x,f11.2))'
        if(iprt_yield.eq.1)
     &     write(880,formatw)ylongi,ylati,(yield(ip),ip=1,npft)
       endif
       write(formatw,*)'(f8.3,1x,f8.3,',npft,'(1x,f11.2))'
       if(iprt_agbiom.eq.1)
     &    write(881,formatw)ylongi,ylati,(ybiomag(ip),ip=1,npft)
       if(iprt_bgbiom.eq.1)
     &    write(882,formatw)ylongi,ylati,(ybiombg(ip),ip=1,npft)     
       write(formatw,*)'(f8.3,1x,f8.3,',npft,'(1x,i4))'
       if(iprt_mat.eq.1)
     &    write(883,formatw)ylongi,ylati,(maturity(ip),ip=1,npft)       
       
c       tempo4 = yfnoburn
c       yfnoburn = -1.
       
CC      do ip = 1, npft       
CC       if (frac(ip).lt.1.e-7) then
CC        tempo1(ip) = ftmin(ip)
CC        ftmin(ip) = -1.
CC        tempo2(ip) = fwat(ip)
CC        fwat(ip) = -1.
CC        tempo3(ip) = ftot(ip)
CC        ftot(ip) = -1.
CC        tempo5(ip) = Fgdd5(ip)
CC        Fgdd5(ip) = -1.
CC        tempo6(ip) = FTmmin(ip)
CC        FTmmin(ip) = -1.
CC        tempo7(ip) = Fwatmin(ip)
CC        Fwatmin(ip) = -1.
CC        tempo8(ip) = fnat(ip)
CC        fnat(ip) = -1.
CC       endif  
CC      enddo
       
c       if (ifrac.eq.1) then
       
        write(formatw,*)'(f8.3,1x,f8.3,',npft,'(1x,f12.8))'
        if(iprt_yfnoburn.eq.1) 
     &     write(83,'(f8.3,1x,f8.3,1x,f10.8)')ylongi,ylati,yfnoburn
        if(iprt_ftomin.eq.1)
     &     write(84,formatw)ylongi,ylati,(ftmin(ip),ip=1,npft)
        if(iprt_ftotw.eq.1)
     &     write(85,formatw)ylongi,ylati,(fwat(ip),ip=1,npft)
        if(iprt_ftot.eq.1)
     &     write(86,formatw)ylongi,ylati,(ftot(ip),ip=1,npft)
c       endif
       
       if (ifrac.eq.1) then
       
        write(formatw,*)'(f8.3,1x,f8.3,',npft,'(1x,f10.8))'
        if(iprt_Fgdd5.eq.1)
     &     write(87,formatw)ylongi,ylati,(Fgdd5(ip),ip=1,npft)
        if(iprt_FTmmin.eq.1)
     &     write(88,formatw)ylongi,ylati,(FTmmin(ip),ip=1,npft)
        if(iprt_Fwatmin.eq.1)
     &     write(89,formatw)ylongi,ylati,(Fwatmin(ip),ip=1,npft)
       endif

c end of if statement on iyprt       
      endif

c       write(formatw,*)'(f8.3,1x,f8.3,',npft,'(1x,f11.2))'
c       if(iprt_nppf.eq.1) 
c     &    write(62,formatw) ylongi,ylati,(ynppf(ip),ip=1,npft)
       
       if (ifrac.eq.1) then
       
        write(formatw,*)'(f8.3,1x,f8.3,1x,f12.8,',npft,'(1x,f12.8))'
        if(iprt_yfnoburn.eq.1) 
     &     write(83,formatw)
     &     ylongi,ylati,yfnoburn,(fnat(ip),ip=1,npft)
     
        write(formatw,*)'(f8.3,1x,f8.3,',npft,'(1x,f12.8))'
        if(iprt_ftot.eq.1)
     &     write(86,formatw)ylongi,ylati,(ftot(ip),ip=1,npft)
     
        endif
       
c       if (imig.eq.1) then
       
        write(formatw,*)'(f8.3,1x,f8.3,',npft,'(1x,f12.8))'
        if(iprt_Fgdd5.eq.1)
     &     write(87,formatw)ylongi,ylati,(Fgdd5(ip),ip=1,npft)
        if(iprt_FTmmin.eq.1)
     &     write(88,formatw)ylongi,ylati,(FTmmin(ip),ip=1,npft)
        if(iprt_Fwatmin.eq.1)
     &     write(89,formatw)ylongi,ylati,(Fwatmin(ip),ip=1,npft)
c       endif

c       yfnoburn = tempo4
         
CC      do ip = 1, npft       
CC       if (frac(ip).lt.1.e-7) then
CC        ftmin(ip) = tempo1(ip)
CC        fwat(ip) = tempo2(ip)
CC        ftot(ip) = tempo3(ip)
CC        Fgdd5(ip) = tempo5(ip)
CC        FTmmin(ip) = tempo6(ip)
CC        Fwatmin(ip) = tempo7(ip)
CC        fnat(ip) = tempo8(ip)
CC       endif  
CC      enddo

 1000 format(6(1x,f6.1),7(1x,f8.0))
 1200 format(12(1x,f5.2))
 1500 format(i3)

      return
      end subroutine wri_res