c=======================================================================
c***********************************************************************
      subroutine funcx(x, fx)
c***********************************************************************
c=======================================================================
c      implicit double precision (a-h,o-z)
      implicit none
      include './com_18/cloud.common'
      real*4, intent(in) :: x
      real*4, intent(out) :: fx
      real*4  :: ecld
c=======================================================================
c   Subroutine funcx is designed by the user to define f(x).
c     x = at entry, contains the value of x at which f(x) is
c         evaluated; it cannot be changed by funcx
c     fx = at exit, fx contains the value of f(x)
c   Variables may be transferred from the main programme or
c   the subroutine calling "nonlineq" through user-defined commons. 
c=======================================================================

      call esat(x,ecld)
      fx = x - tk * ((ecld/eh2o)**rscp_air)

      return
      end


c=======================================================================
c***********************************************************************
      subroutine check(stept,time,y,drv)
c***********************************************************************
c=======================================================================
c      implicit double precision (a-h,o-z)
      implicit none

      include './com_18/parameter.common'
      include './com_18/climin.common'
      include './com_18/cstpi.common'
      include './com_18/cte.common'
      include './com_18/eco.common'
      include './com_18/envi.common'
      include './com_18/flux_w.common'
      include './com_18/monthcst.common'      
      include './com_18/monwat.common'
      include './com_18/snow.common'
      include './com_18/temper.common'
      include './com_18/varday.common'
      include './com_18/varnow.common'
      include './com_18/waflux.common'      
      real*4 stept
c-----------------------------------------------
c JLP ajouté pour implicit none
c
      integer idn,ip,m,nr,ny0
      real*8  dn,drv,time,y
c
c-----------------------------------------------
      
      dimension y(nequat),drv(nequat)

      ny0 = int(time/float(nd)+0.000001)+1
      dn  = time - float(ny0-1) * float(nd)
      idn=int(dn+1.00001)

         do nr =1,nres
           sumnet(nr) = sumnet(nr) + drv(nr)*stept
         enddo

         aswday(idn) = asw
         tladay(idn) = tlai

         water(idn) = asw
         snow_frac(idn) = fsn

         if (asw.lt.aswmin) aswmin=asw

c   rblday: carbon aerodynamic resistance (mol-1 m2 s)
c ----------------------------------------------------------------------
         do ip=1,10
            rblday(idn,ip) = 0.0244*((temi+temp0)/temp0)
     &                  *(patm0/patm)*rblcv(ip)
         enddo
         
c        sets monthly variables needed by CARAIB         
         if (idn.eq.1) then
           do m = 1,nm
             swcar(m) = 0.
             rtrcar(m) = 0.
             fsncar(m) = 0.
             svecar(m) = 0.
           end do
         endif
         m = imonth(idn)
         swcar(m) = swcar(m) + asw / float(mlength(m))
         rtrcar(m) = rtrcar(m) + max(rtrans,0.6d0) / float(mlength(m))
         fsncar(m) = fsncar(m) + fsn / float(mlength(m))
         svecar(m) = svecar(m) + svevp     
         

      return
      end subroutine funcx