c=======================================================================
c***********************************************************************
      subroutine ctgen
c***********************************************************************
c=======================================================================
c=======================================================================
c   reads constants for weather generator and 'sets' them in commons
c   variables declaration
c=======================================================================
      implicit none
      
      include './com_18/parameter.common'
      include './com_18/lstz.common'
      include './com_18/lstcli.common'
      include './com_18/lstreg.common' 
      

c=======================================================================
c   climatic zones lists
c=======================================================================
      data listezone/'A1Af',    'A2Af',    'A3Af',    'A4Af',    'A1Am',
     &               'A2Am',    'A3Am',    'A4Am',    'A1Aw',    'A2Aw',
     &               'A3Aw',    'A4Aw',    'A1As',    'A2As',    'A3As',
     &               'A4As',   'B1Bwh','B2Bwhprh','B2Bwhprs','B3Bwhprh',
     &           'B3Bwhprs',   'B4Bwh',   'B5Bwh',   'B6Bwh',   'B1Bwk',
     &           'B2Bwkprh','B2Bwkprs','B3Bwkprh','B3Bwkprs',   'B4Bwk',
     &              'B5Bwk',   'B6Bwk',   'B1Bsh','B2Bshprh','B2Bshprs',
     &           'B3Bshprh','B3Bshprs',   'B4Bsh',   'B5Bsh',   'B6Bsh',
     &              'B1Bsk','B2Bskprh','B2Bskprs','B3Bskprh','B3Bskprs',
     &              'B4Bsk',   'B5Bsk',   'B6Bsk',   'C1Cfa',   'C2Cfa',
     &           'C3Cfaprh','C3Cfaprs',   'C4Cfa',   'C5Cfa',   'C6Cfa',
     &              'C1Cfb',   'C2Cfb','C3Cfbprh','C3Cfbprs',   'C4Cfb',
     &              'C5Cfb',   'C6Cfb',   'C1Cfc',   'C2Cfc','C3Cfcprh',
     &           'C3Cfcprs',   'C4Cfc',   'C5Cfc',   'C6Cfc',   'C1Cfd',
     &              'C2Cfd','C3Cfdprh','C3Cfdprs',   'C4Cfd',   'C5Cfd',
     &              'C6Cfd',   'C1Cwa',   'C2Cwa','C3Cwaprh','C3Cwaprs',
     &              'C4Cwa',   'C5Cwa',   'C6Cwa',   'C1Cwb',   'C2Cwb',
     &           'C3Cwbprh','C3Cwbprs',   'C4Cwb',   'C5Cwb',   'C6Cwb',
     &              'C1Cwc',   'C2Cwc','C3Cwcprh','C3Cwcprs',   'C4Cwc',
     &              'C5Cwc',   'C6Cwc',   'C1Cwd',   'C2Cwd','C3Cwdprh',
     &           'C3Cwdprs',   'C4Cwd',   'C5Cwd',   'C6Cwd',   'C1Csa',
     &              'C2Csa','C3Csaprh','C3Csaprs',   'C4Csa',   'C5Csa',
     &              'C6Csa',   'C1Csb',   'C2Csb','C3Csbprh','C3Csbprs',
     &              'C4Csb',   'C5Csb',   'C6Csb',   'C1Csc',   'C2Csc',
     &           'C3Cscprh','C3Cscprs',   'C4Csc',   'C5Csc',   'C6Csc',
     &              'C1Csd',   'C2Csd','C3Csdprh','C3Csdprs',   'C4Csd',
     &              'C5Csd',   'C6Csd',   'D1Dfa',   'D2Dfa',   'D3Dfa',
     &              'D1Dfb',   'D2Dfb',   'D3Dfb',   'D1Dfc',   'D2Dfc',
     &              'D3Dfc',   'D1Dfd',   'D2Dfd',   'D3Dfd',   'D1Dwa',
     &              'D2Dwa',   'D3Dwa',   'D1Dwb',   'D2Dwb',   'D3Dwb',
     &              'D1Dwc',   'D2Dwc',   'D3Dwc',   'D1Dwd',   'D2Dwd',
     &              'D3Dwd',   'D1Dsa',   'D2Dsa',   'D3Dsa',   'D1Dsb',
     &              'D2Dsb',   'D3Dsb',   'D1Dsc',   'D2Dsc',   'D3Dsc',
     &              'D1Dsd',   'D2Dsd',   'D3Dsd',    'E1ET',    'E2ET',
     &               'E3ET',    'E4ET',    'E1EF',    'E2EF',    'E3EF',
     &               'E4EF'/ 

      data climatslst / 'Af', 'Am', 'Aw', 'As','Bwh','Bwk','Bsh','Bsk',
     &                 'Cfa','Cfb','Cfc','Cfd','Cwa','Cwb','Cwc','Cwd',
     &                 'Csa','Csb','Csc','Csd','Dfa','Dfb','Dfc','Dfd',
     &                 'Dwa','Dwb','Dwc','Dwd','Dsa','Dsb','Dsc','Dsd',
     &                  'ET', 'EF'/

      data reg /'A','A','A','A','B','B','B','B','C','C','C','C','C','C',
     &          'C','C','C','C','C','C','D','D','D','D','D','D','D','D',
     &          'D','D','D','D','E','E'/
     
      return 
      end subroutine ctgen