c=======================================================================
c***********************************************************************
      subroutine cth2o
c***********************************************************************
c=======================================================================

c=======================================================================
c     reads constants and 'sets' them in commons
c     variables declaration
c=======================================================================
c      implicit double precision (a-h,o-z)
      IMPLICIT NONE
      include './com_18/parameter.common'
      include './com_18/climin0.common'
      include './com_18/cte.common'
      include './com_18/cstpi.common'
      include './com_18/c3en.common'
      include './com_18/c3cst.common'
      include './com_18/c4cst.common'
      include './com_18/cstmort.common'
      include './com_18/deltac13.common'
      include './com_18/down_reg.common'
      include './com_18/ecopro.common'
      include './com_18/envi.common'
      include './com_18/estab.common'
      include './com_18/files_car.common'
      include './com_18/files_ibm.common'
      include './com_18/firevpar.common'      
      include './com_18/gama.common'
      include './com_18/gk.common'
      include './com_18/griddata.common'
      include './com_18/hcst.common'
      include './com_18/h2ocst.common'
      include './com_18/init.common'
      include './com_18/input_par.common'
      include './com_18/lai.common'
      include './com_18/laiste.common'
      include './com_18/monthcst.common'
      include './com_18/monthcst2.common'
      include './com_18/nspc.common'
      include './com_18/pho_sch.common'
      include './com_18/plant_evol.common'
      include './com_18/plheight.common'
      include './com_18/prt.common'
      include './com_18/radcst.common'
      include './com_18/rblcst1.common'
      include './com_18/solpar.common'
      include './com_18/sresp.common'
      include './com_18/temper.common'
      include './com_18/textcst1.common'
      include './com_18/tresh.common'
      include './com_18/veglab.common'
      include './com_18/xlaic.common'

c-----------------------------------------------
c JLP ajout� pour implicit none
c
      integer ip,ipft,iphen,ipool,k,m
      real*4  csurn,disds,exc2,exc3,gkres,gkres0,rholeaf,steplai,tauleaf
cIngrid201806-aNitr
     &      ,vcm0fac,xkainv,z0s,aNitr
c
c-----------------------------------------------

      dimension csurn(nplant,npool)
      character*50 title
      character*132 sdata

c      data mdur /31,28,31,30,31,30,31,31,30,31,30,31/

      nsyr = 0

c=======================================================================
c   reads PFT parameters :
c   alvsw and alvlw : short and long wave albedos
c   zzra            : reference height for wind measurements
c   rdveg           : rooting depth of vegetation
c   t1 and t2       : temperatures for beginning and end of LAI increase
c   xlmin and xlmax : minimal and maximal LAI values before t1 and 
c                   after t2
c=======================================================================

      open(13,file=filbagibm,status='old')
      read(13,*)title
      do ip = 1, npft
         read(13,133)pft_name(ip),sdata
         read(sdata,*)alvsw(ip),alvlw(ip),rdveg(ip),t1pft(ip),t2pft(ip)
     &               ,xlmin(ip),xlmax(ip),z0vw(ip),z0vs(ip),disd(ip)
     &               ,zzra(ip),emv(ip),wai(ip),alvwd(ip)

      enddo
c133   format(a53,a80)
133   format(a53,a132)
      close(13)

c=======================================================================
c   reads PFT tolerance parameters
c=======================================================================
      open(14,file=filebagtol)
      read(14,*)title
      do ip = 1, npft
       read(14,125) pft_name(ip),sdata
       read(sdata,*)ipft,ic4(ip),idec(ip),ttreshi1(ip),
     &        ttreshi2(ip),ttresha1(ip),ttresha2(ip),
     &        wattresh1(ip),wattresh2(ip),xpar_tresh1(ip),
     &        xpar_tresh2(ip),gdd_est(ip),tcmax_est(ip),
     &        watmax_est(ip),pgerm(ip),bag_h(ip)
       if(watmax_est(ip).le.0.) then
         write(61,*) 'attention this BAG will never exist',ip
         stop
       endif
      enddo

125   format(a50,a132)
      close(14)

c=======================================================================
c   reads or computes various PFT parameters
c=======================================================================
      open(15,file=filebagpar)
      read(15,*)title
      do ip = 1, npft
       read(15,126) pft_name(ip),sdata
       read(sdata,*)g0(ip),g1(ip),splai(ip),delc2(ip),
     &     xip(ip,1),xip(ip,2),rese_frac(ip),xkainv,
     &     rootf(ip),rvcm567(ip),rjm567(ip),rootsh(ip),
     &     phi_L(ip),phi_S(ip),phi_R(ip),phi_D(ip),
     &     psi_L(ip),psi_S(ip),psi_R(ip)
       xkappa(ip) = 1./xkainv
      enddo
126   format(a50,a132)
      close(15)
            
c=======================================================================
c   reads C:N of PFT vegetation parts
c=======================================================================
      open(16,file=filecsurn)
      read(16,*)title
      do ip = 1, npft
       read(16,126) pft_name(ip),sdata
       read(sdata,*)(csurn(ip,k),k=1,npool)
      enddo
      close(16)
      
c=======================================================================
c   reads residence times of plant parts
c   transform tau(yr) into gk_fall(day-1)
c=======================================================================
      open(17,file=filegkf)
      read(17,*)title
      do ip = 1, npft
         read(17,126) pft_name(ip),sdata
         read(sdata,*)(gk_fall(ip,k,1),k=1,npool),
     &       (gk_fall(ip,k,2),k=1,npool),
     &       (gk_fall(ip,k,3),k=1,npool),gkboom(ip),poro_crit(ip)
      enddo
      close(17)
      
      do ip = 1, npft
         gkboom(ip) = 1./(365.*gkboom(ip))
         do ipool = 1, npool
            do iphen = 1, 3
               gk_fall(ip,ipool,iphen) = 
     &                 1./(365.*gk_fall(ip,ipool,iphen))
            enddo
         enddo
      enddo

c=======================================================================
c   reads gama1, gama2 parameters (litter, soil C deg) (yr -1 ????)
c=======================================================================

      open(18,file=filegama)
      read(18,126)title,sdata
      read(sdata,*)gama1(1),gama1(2),gama2
      close(18) 

c      gama1(1) = 20.
c      gama1(2) = 5.
c      gama2    = 0.2      !previous standard value for CARAIB
cc      gama2    = 0.1
      
c=======================================================================
c   reads initial values of carbon pools
c=======================================================================
      open(19,file=filecinit)
      read(19,*)title
      do ip = 1, npft
         read(19,126) pft_name(ip),sdata
         read(sdata,*)(carb_init(ip,k),k=1,npool)
      enddo
      close(19)

c=======================================================================
c   fractionation linked to diffusion through stomatal cavities 
c=======================================================================
      delc1 = 4.4

c=======================================================================
c   timeday = factor use to calculate all parameters only for
c             the first half of the day.
c=======================================================================

      timeday =  2.

      do m = 1, nm
c         xmfac(m) = 365. / (12. * float(mlength(m)))
         xmfac(m) = 1.
      enddo

c=======================================================================
c   first hour, last hour, hourstep
c=======================================================================

      xhstep = float(2)
      pi     =      3.141592654
      h_step = xhstep * pi / 12.

c=======================================================================
c   steplai = leaf area index layers thickness;
c   nlmin   = initial value of the minimum LAI;
c   transfo = factor to transform the co2 assimilation in gc m-2 d-1:
c             1.e-6: micro moles --> moles;
c             12.  : moles       --> g of carbon;
c             3600 : s-1         --> h-1;
c             timeday * xhstep:  --> d-1
c             steplai:           --> 1 lai layer value.
c=======================================================================
      xlaimax  = 6.
      steplai  = xlaimax/float(nlay)
CLAI      transfw  = 3600. * steplai * timeday * xhstep
CLAI      transfo  = 1.e-6 * 12. * transfw
      transfw  = 3600. * timeday * xhstep
      transfo  = 1.e-6 * 12. * transfw
c=======================================================================
c   ome     = reflection + scattering factor (dimensionless);
c   facome  = radiative transfer factor;
c   radun   = transformation from solar irradiance (w m-2) to
c             absorbed irradiance (micromol m-2 s-1):
c             1 - 0.23 : light absorbed by other than Chloroplast
c             1 - ome  : non reflected ligth;
c             3.6  e-19: energy of APAR photon (J);
c             6.022e+17: Avogadro number.
c   parun   = unit transformation of par: J s-1 m-2 ==> MJ day-1 m-2
c             3600: s ==> hour
c             xhstep: to take into account the time step
c             timeday: to count a.m and p.m.
c             10-6 : j ==> MJ
c   clump_fac = clumping factor
c=======================================================================
      rholeaf = 0.10
      tauleaf = 0.10
      ome = rholeaf + tauleaf
      facome = sqrt((1. -tauleaf)*(1.-tauleaf) - rholeaf*rholeaf)
      rhoc0 = (1. - tauleaf - facome) / rholeaf
      radun = (1.-0.23)  / (3.6e-19*6.022e+17)
      parun = 3600. * xhstep * timeday / 1000000.
      clump_fac = 0.8

c=======================================================================
c   c3 species constants at 25 c:
c
c   g0      = intercept for the stomatal conductance;
c   g1      = slope for the stomatal conductance;    
c   gkc3    = michaelis constant for co2 (mubar);                   
c   gko3    = michaelis constant for o2 (mbar);
c   pkc3    = turnover number of rup2 carboxylase (s-1);            
c   pkcko   = ratio between the turnover number of rup2 carboxylase 
c             and the turnover of rup2 oxygenase;
c   vcm0    = maximum RUBISCO capacity for C3 species (mumol m-2 s-1);
c   gjm0    = maximum electron transport rate for C3 species 
c            (muE m-2 s-1).
c=======================================================================
      gkc3     =   460.
      gko3     =   330.
      pkc3     =     2.5
      pkcko    =     0.21
c      gkres0   = 0.0130
      gkres0   = 0.0117
c      gkres0   = 0.01037      
      gkres    = gkres0 * timeday * xhstep

c=======================================================================
c   Dark respiration is directly related to Vcmax, to give consistency
c   between the dark respiration used in the GPP calculation from
c   Farquhar and the present calculation vcmax is related to gkres0.
c   The value of vcm0fac obtained here is close to the one (30) from
c   Nys (measurements).
c
c      12.: is the weigth of one mole of carbon
c      1.e-6: gives vcmax in micromolC 
c      3600: transform hours in seconds
c      0.01: is the ratio rd / vcmax
c
c   In fact to be coherent with measurements, gkres0 / rdsurvc0
c   have to be so that vcm0fac = 30, and since gkres0 = 0.013 
c   form measurements....
c   vcm0 = 80.,80.,120.,120.,40.,50.,40.,50. 
c======================================================================
c      rdsurvc0 = 0.010
      rdsurvc0 = 0.009
c      rdsurvc0 = 0.008      
      vcm0fac = gkres0 / (12. * 3600 * 1.e-6 * rdsurvc0)
      do ip = 1, npft
c Ingrid201806 / Louis
c old parameterisation from CARAIB
c        vcm0(ip) = vcm0fac / (csurn(ip,1) * splai(ip))
c        vcm0(ip) = vcm0fac / (csurn(ip,1) * 0.025)
c        vcm0(ip) = vcm0fac / (csurn(ip,1) * 0.0225)
c        vcm0(ip) = vcm0fac / (csurn(ip,1) * 0.020)      

c parameterisation of Vcmax from:
c    Walker et al. 2014. Ecol & Evol., 4(16):3218-3235
c       aNitr = leaf nitrogen per unit area (g N /m2)

        aNitr = 1/((12.*csurn(ip,1)/14.)*splai(ip))
	vcm0(ip)=exp(1.993+2.555*alog(aNitr)-0.372*alog(splai(ip))
     &           +0.422*alog(aNitr)*alog(splai(ip)))
     
        do ipool = 1, npool
          gk1_25(ip,ipool) = gkres 
     &                         / csurn(ip,ipool)
        enddo 
      enddo 
      
      h_grow  = 0.20

c=======================================================================
c   other c3 constants, energy:
c
c   rgas    = gas constant (j k-1 mol-1);
c   ejm     = energy ... (j mol-);
c   sjm     = .... (j k-1 mol-1);
c   hjm     = .... (j mol-1).
c   eagkc   = activation energy for gkc (j);
c   eagko   = activation energy for gko (j);
c   eapkc   = activation energy for pkc (j).   
c=======================================================================
      rgas    =      8.314
      rgas_v  =      rgas/0.018
      ejm     =  37000. / (298.15 * rgas)
      sjm     =    710. / rgas
      hjm     = 220000. / rgas
      eagkc   =  59000. / (298.15 * rgas)
      eagko   =  36000. / (298.15 * rgas)
      eapkc   =  59000. / (298.15 * rgas)

c=======================================================================
c   constants for c4:                                            
c                                       
c   alpc4   = quantum efficiency (mol mol-1);                     
c   xkc4    = initial slope of the photosynthesis co2 response
c             (micromol m-2 s-1);
c   q10     = proportional increase in a parameter value for a 10
c            degrees increase.
c=======================================================================
      alpc4   =  0.04
      xkc4    = 0.7
      q10     =  2.
      fact0   = 0.3 * 286.15
      fact1   = 0.3 * 309.15
      fact2   = 1.3 * 328.15

c=======================================================================
c   temp0   = temperature of 0 degree Celsius (K).
c=======================================================================

      temp0   =    273.15

c======================================================================
c     coefficient to calculation the atmospheric water partial pressure
c======================================================================
      ah2o    = -2937.4
      bh2o    =    -4.9283
      ch2o    =    23.5518
      dh2o    = 6.180178
      eh2o    = 51012. / (rgas * temp0)

c=======================================================================
c   pi     = trigonometric constant (dimensionless);
c   sunea  = solar constant (W m-2);
c   rearth = earth radius (km);
c   hatm   = atmosphere thickness (km) (dense part);
c   ftrmax = maximum transmittance of the atmosphere (dimensionless).
c   sigma  = Stefan-Boltzmann constant
c   sunea   = solar constant (wm-2 ?);
c   rearth  = earth radius (km);
c   hatm    = atmosphere height (km) (dense part);
c   ftrmin  = minimum transmittance of the atmosphere (dimensionless);
c   ftrmax  = maximum transmittance of the atmosphere (dimensionless).
c=======================================================================

      pi      = 3.1415926535
      pi2     = 2. * pi
      pi180   = pi / 180.
      
      if (ileap.eq.1) then 
       pi365   = pi2 / 365.2425
      else
       pi365   = pi2 / 365.
      endif

      sunea  =   1368.
      rearth =   6370.
      hatm   =     10.
      
c  CARAIB original values      
      ftrmin =      0.251
      ftrmax =      0.760
c  Oensingen site      
c      ftrmin =      0.251
c      ftrmax =      0.650
c  Vielsalm site      
c      ftrmin =      0.050
c      ftrmax =      0.810
c      ftrmin =      0.150
c      ftrmax =      0.800

      sigma  = 5.67d-8

      if(ipar.eq.0) then
       xlsper  =    xlsper * pi / 180.
       obl     =     obl * pi / 180.

       exc2    = exc * exc
       exc3    = exc2 * exc
       exc4    = 2. * exc
       exc5    = 2.5 * exc2
      endif
      
      rearth2 = rearth * rearth
      hatrea  = hatm * ( hatm + 2. * rearth)

c=======================================================================
c   psat0: saturated partial pressure of H2O at t=O C  (Pa) 
c   eaice: chaleur latente L d'evaporation de H2O [J mol-1] 
c   cpdry: specific heat cp of dry air at constant p [J kg-1 K-1] 
c   cph2o: specific heat of water vapour at constant p [J kg-1 K-1] 
c   patm0: sea level pressure (Pa) 
c   h2omw = water molecular weight (kg mol-1) 
c   drymw = dry air molecular weight (kg mol-1) 
c   epsi   = ratio of water to air molecular weight 
c   rdry = gas constant of dry air Rdry = Rgas/drymw (J K-1 kg-1) 
c   rh2o = gas constant of water vapour Rh2o = Rgas/h2omw (J K-1 kg-1)
c=======================================================================
      asat=6763.6
      bsat=4.9283
      csat=54.233
      psat0=100.*exp(-asat/temp0-bsat*alog(temp0)+csat)
      eaice = 51012.
      cpdry = 1004.
      cph2o = 1952.
      patm0 = 1.013d+5
      drymw = 28.964d-3
      h2omw = 18.016d-3
      epsi = h2omw/drymw
      rdry = rgas/drymw
      rh2o = rgas/h2omw

c======================================================================
c   aerodynamic + boundary layer resistance constants
c======================================================================
      zzras = 100.00
      z0s = 0.0006
      disds = 0.004
      zzlogs = log((zzras-disds)/z0s)
      usmuls = 0.40/zzlogs
      arbl      =  0.40
      brbl      =  6.2
      exrbl     =  0.67
      unitfac   = rgas*temp0/patm0
      h2osurco2 =  1.37

c======================================================================
c   coefficient for different soil textures
c======================================================================
      cmoptcla = 0.73
      cmoptsil = 0.68
      cmoptsan = 0.59
      xm1cla   = -1.883
      xm1sil   = 0.140
      xm1san   = 0.356
      psatcla  = 0.75
      psatsil  = 0.625
      psatsan  = 0.5

c=======================================================================
c   coefficient for the calculation of soil respiration
c   alpha = proportion of litter decomposition carbon flux transferred 
c           to humus pool (dimensionless)
c           (1-alpha is transferred to atmosphere as CO2)
c   q10grnd = q10 for decomposition of metabolic (leaf) litter 
c   q10tree = q10 for decomposition of structural (wood) litter and humus
c   facgrnd = proportionality factor for decomposition of metabolic 
c            (leaf) litter 
c   factree = proportionality factor for decomposition of structural 
c            (wood) litter and humus 
c=======================================================================
      q10tree = 1.74
      factree = (1. - 0.33) * 0.00555 * 12. / 365.
      q10grnd = 2.03
      facgrnd = (1. - 0.33) * 0.00343 * 12. / 365.
      alpha = 0.18

c=======================================================================
c   parameters used to smooth the mortality function with a normal law
c      for min temperature, soil water content and GDD5
c=======================================================================
      xk_erf = 2.33

      delta_tmin = 3.
      delta_watmin = 5./100.

      delta_tmax = 3.
      delta_watmax = 5./100.
      delta_gdd5   = 5./100.

      if(delta_watmin .gt. 1. .or.
     &   delta_watmax .gt. 1. .or.
     &   delta_gdd5   .gt. 1.) then
         write(61,*) 'error input delta',delta_watmin,delta_watmax,
     & delta_gdd5
         stop
      endif

      return
end subroutine cth2o