c=======================================================================
c***********************************************************************
      subroutine funcx2(x, fx)
c***********************************************************************
c=======================================================================
c jlp      implicit double precision (a-h,o-z)
      implicit none      
      include './com_18/parameter.common'
      include './com_18/cstpi.common'
      include './com_18/cte.common'
      include './com_18/kernel.common'
c-----------------------------------------------
c JLP ajout� pour implicit none
c
      integer i
c
c-----------------------------------------------
      
      real*4 :: zref,Karm,Co,hv,d,z0,vt,H0_rh,zm,alph,
     &          scalefactor,sigm,
     &          wald,wald_max,my,lambda,
     &          sum_wald,sum_wald_max,U,mu,sig 
      real*8 x,fx   

c-------------------------------------------------------------------
c   Subroutine funcx is designed by the user to define f(x).
c     x = at entry, contains the value of x at which f(x) is
c         evaluated; it cannot be changed by funcx 
c     fx = at exit, fx contains the value of f(x)
c   Variables may be transferred from the main programme or
c   the subroutine calling "nonlineq" through user-defined commons. 
c-------------------------------------------------------------------- 
       
       zref = 10. ! H�he der ZAMG Windgeschwindigkeitsmessungen
       Karm = 0.6 ! von Karman constant (0.6 f�r Waldinneres (siehe Thompson & Katul 2008), 0.4 f�r offene Vegetation (Katul et al. 2005))
       Co = 3.125 ! Kolmogorov constant (after Skarpaas et al. 2007)
       hv = 30. ! vegetation height
       d = 0.7 * hv ! following Soons et al. (2004), see also Skarpaas et al.(2007)
       z0 = 0.1 * hv ! following Soons et al. (2004), see also Skarpaas et al.(2007)
       vt = 0.57 ! terminal velocity
       H0_rh = 25. ! release height 
       zm = hv + zref ! angenommene H�he der Windgeschwindigkeitsmessung - standardisiert als zref (der Messh�he der empirischen Daten der ZAMG) �ber der canopy height h, cf. Thompson & Katul (2008)
       alph = 0.1
 
              
       if(isp.eq.8) then
       
       scalefactor = (1-exp(-alph))/alph
       sigm = (2*(1.3**2))*Karm
     &        *((H0_rh-d)/(Co*scalefactor*log((zm-d)/z0)))**0.5  
       
       sum_wald = 0.
       sum_wald_max = 0.
      
        
        do i = 1, 96
        
          U = midpoint_pi(i) * scalefactor
          my = (H0_rh*U)/vt
          lambda = (H0_rh/sigm)**2.

          wald = ((lambda/(2.*pi*(x)**3.))**0.5
     &      *exp((-lambda*(x-my)**2.)/(2.*my**2.*x))) 
 
          wald_max = ((lambda/(2.*pi*(Xmax)**3.))**0.5
     &      *exp((-lambda*(Xmax-my)**2.)/(2.*my**2.*Xmax)))
          
         sum_wald = sum_wald + wald*probdenswind_pi(i)  
         sum_wald_max = 
     &      sum_wald_max + wald_max*probdenswind_pi(i)
          
        enddo
        
        fx = spec_npp*sum_wald/(2.*pi*(x+1./2.)) 
     &  - ynppf_max*sum_wald_max/(2.*pi*(Xmax+1./2.)) 
     
c        fx = spec_npp*sum_wald - ynppf_mean*sum_wald_max
        
        endif
        
        if(isp.eq.6) then
        
        sig = 2.9
        mu = 5.1
        
        fx = ((spec_npp*(1./((2.*pi)**0.5*sig*x))
     &     *exp(-(((log(x)-mu))**2./(2.*(sig)**2.))))
     &          /(2.*pi*(x+1./2.)))
     &       -((ynppf_max*(1./((2.*pi)**0.5*sig*Xmax))
     &     *exp(-(((log(Xmax)-mu))**2./(2.*(sig)**2.))))
     &          /(2.*pi*(Xmax+1./2.)))
        
        endif
       
      return
      end subroutine funcx2