c=======================================================================
c***********************************************************************
      subroutine monthparam
c***********************************************************************
c=======================================================================
c=======================================================================
c   reads constants for weather generator and 'sets' them in commons
c   variables declaration
c=======================================================================
      implicit none
      include './com_18/parameter.common'
      include './com_18/monthcst.common' 
      
      integer m,iday
     
c=======================================================================
c   reference times for the seasonal cycle modeling:
c
c   imonth = month corresponding to each day;
c   mlength = length of each month;
c   numday  = representative day for each month.
c=======================================================================
      
      if (nd.eq.360) then
        do m = 1, 12
	  mlength(m) = 30
	end do
      else
        mlength(1) = 31
        if (nd.eq.365) then 
	  mlength(2) = 28
	else
	  mlength(2) = 29
	endif	 	
        mlength(3) = 31
        mlength(4) = 30      
        mlength(5) = 31
        mlength(6) = 30       
        mlength(7) = 31
        mlength(8) = 31
        mlength(9) = 30      
        mlength(10) = 31
        mlength(11) = 30       
        mlength(12) = 31
      endif      


      do iday = 1, nd
         imonth(iday) = 1
      enddo
      
      ini(1) = 1
      ifin(1) = mlength(1)
      do m = 2, nm
	 ini(m) = ini(m-1) + mlength(m-1)
	 ifin(m) = ifin(m-1) + mlength(m)
         do iday = ini(m), ifin(m)
            imonth(iday) = m
         enddo
      enddo
      
      do m = 1, nm
        mondec(m) = m 
	numday(m) = (ini(m)+ifin(m))/2
      end do 

      return
      end subroutine monthparam