c=======================================================================
c***********************************************************************
      subroutine neighborhood(ngt)
c***********************************************************************
c=======================================================================      

      IMPLICIT NONE
c-- JLP      implicit double precision (a-h,o-z)

      include './com_18/parameter.common'
      include './com_18/coord.common'
      include './com_18/cstpi.common'
      include './com_18/cte.common'
      include './com_18/disper.common'
      include './com_18/griddata.common'
      include './com_18/input_par.common'
      
      integer i,j,k,ngt
      double precision xlg1,xlt1,xlg2,xlt2,distan
        
      
      ylongi = xlg(ngt)
      ylati = xlt(ngt)
      
      do k = 1, n_nghmx
       neighbor(k,ngt) = 0
      end do 
      
      n_nghi = 0
      
      do i = 1, n_pix
       if (i.ne.ngt) then   
        do j = 1, ncor(ngt)
         do k = 1, ncor(i)
          if (abs(xlgcor(k,i)-xlgcor(j,ngt)).lt.prec_co) then
           if (abs(xltcor(k,i)-xltcor(j,ngt)).lt.prec_co) then
            n_nghi = n_nghi+1
            if (n_nghi.gt.n_nghmx) then 
             write(*,*)'Maximum number of neighbors n_nghmx=',n_nghmx,
     &     ' not large enough',
     &     ' Increase its value in parameter.common - Program Stop'
             write(61,*)'Maximum number of neighbors n_nghmx=',n_nghmx,
     &     ' not large enough',
     &     ' Increase its value in parameter.common - Program Stop'
             stop
            endif     
            neighbor(n_nghi,ngt)=i
            go to 100
           endif
          endif
         end do
        end do
 100    continue
       endif
      end do
      
      n_ngh(ngt) = n_nghi
      
      do k = 1, n_ngh(ngt)
        i = neighbor(k,ngt)
        xlg1 = xlg(i)
        xlt1 = xlt(i)
        xlg2 = ylongi
        xlt2 = ylati
        ylon(k,ngt)= (xlg1+xlg2)/2.
        ylat(k,ngt)= (xlt1+xlt2)/2.
        call distance(xlg1,xlt1,xlg2,xlt2,distan)
        dist_ngh(k,ngt)=distan                
      end do
      
        write(61,'(3x,i7,2(1x,f9.4),8(3x,i7))') 
     &                  ngt,ylongi,ylati,(neighbor(k,ngt),k=1,n_nghi)   
        write(61,'(30x,8(1x,f9.4))') (ylon(k,ngt),k=1,n_nghi)
        write(61,'(30x,8(1x,f9.4))') (ylat(k,ngt),k=1,n_nghi)

      return 
      end subroutine neighborhood