c=======================================================================
c***********************************************************************
      subroutine read_lu(ngt,iread)
c***********************************************************************
c=======================================================================

c=======================================================================
c     This routine reads land use data 
c=======================================================================

c      implicit double precision (a-h,o-z)
      implicit none
      
      include './com_18/parameter.common'
      include './com_18/annee.common'      
      include './com_18/coord.common'
      include './com_18/cte.common'
      include './com_18/griddata.common'
      include './com_18/icyr.common'                  
      include './com_18/landuse.common'
      include './com_18/landuse0.common'            
      include './com_18/nspc.common'

c-----------------------------------------------
c JLP ajout� pour implicit none
c
      real*4  a8,b8
c
c-----------------------------------------------
      
      integer ngt,iread
      real*4 frac_tot, frac_tot0

c=======================================================================
c     longitude and latitude of pixel 
c=======================================================================

      ylongi = xlg(ngt)
      ylati = xlt(ngt)

c=======================================================================
c     records previous year land use fractions 
c=======================================================================
      if (nyear.ne.1) then
       frac_nat0(ngt)  = frac_nat(ngt)
       frac_crop0(ngt) = frac_crop(ngt)
       frac_past0(ngt) = frac_past(ngt)
       frac_urb0(ngt)  = frac_urb(ngt)
       frac_rock0(ngt) = frac_rock(ngt)
       frac_wat0(ngt)  = frac_wat(ngt) 
      endif       

c=======================================================================
c     reads land use fractions (natural vegetation, crops, pastures, 
c               urban, bare rocks, water) 
c=======================================================================
      if (ilu.eq.1) then
       read(94,*) a8,b8,frac_nat(ngt),frac_crop(ngt),frac_past(ngt)
     & ,frac_urb(ngt),frac_rock(ngt),frac_wat(ngt)
      else
       frac_nat(ngt)  = 1.
       frac_crop(ngt) = 0.
       frac_past(ngt) = 0.
       frac_urb(ngt)  = 0.
       frac_rock(ngt) = 0.
       frac_wat(ngt)  = 0.
      endif
      
      frac_tot = frac_nat(ngt)+frac_crop(ngt)+frac_past(ngt)
     & +frac_urb(ngt)+frac_rock(ngt)+frac_wat(ngt) 
     
      if (abs(frac_tot-1.).ge.2.e-3) then
          
       if((frac_tot.lt.0.).or.(frac_tot.gt.1.)) then
         write(61,*) 'error, incorrect input cover fractions',frac_tot,
     &      frac_nat(ngt),frac_crop(ngt),frac_past(ngt),frac_urb(ngt),
     &      frac_rock(ngt),frac_wat(ngt)
         stop
       endif

       if(frac_tot.gt.0. .and. frac_tot.lt.1.) then
        write(61,*) 'your input cover fractions do not cover the pixel',
     &      frac_nat(ngt),frac_crop(ngt),frac_past(ngt),frac_urb(ngt),
     &      frac_rock(ngt),frac_wat(ngt)

       endif
      endif
      
c=======================================================================
c     initializes previous year land use fractions on first year
c=======================================================================
      if (nyear.eq.1) then 
       if ((ifrac_rd.ge.1).and.(icyr_landuse.ne.0)) then
        if (ilu.eq.1) then	 
	 read(425,*) a8,b8,frac_nat0(ngt),frac_crop0(ngt),
     &    frac_past0(ngt),frac_urb0(ngt),frac_rock0(ngt),frac_wat0(ngt)
     
         frac_tot0 = frac_nat0(ngt)+frac_crop0(ngt)+frac_past0(ngt)
     &      +frac_urb0(ngt)+frac_rock0(ngt)+frac_wat0(ngt) 
     
         if (abs(frac_tot0 - 1.).ge.2.e-3) then
          
           if((frac_tot0.lt.0.).or.(frac_tot0.gt.1.)) then
            write(61,*) 'error, incorrect input cover fractions',
     &      ' of the previous year :',
     &      frac_tot0,frac_nat0(ngt),frac_crop0(ngt),frac_past0(ngt),
     &      frac_urb0(ngt),frac_rock0(ngt),frac_wat0(ngt)
            stop
           endif

           if(frac_tot0.gt.0. .and. frac_tot0.lt.1.) then
            write(61,*) 'your input cover fractions of previous year',
     &      ' do not cover the pixel',
     &      frac_tot0,frac_nat0(ngt),frac_crop0(ngt),frac_past0(ngt),
     &      frac_urb0(ngt),frac_rock0(ngt),frac_wat0(ngt)

           endif
         endif     
     
	else
         frac_nat0(ngt)  = 1.
         frac_crop0(ngt) = 0.
         frac_past0(ngt) = 0.
         frac_urb0(ngt)  = 0.
         frac_rock0(ngt) = 0.
         frac_wat0(ngt)  = 0.	
	endif 
       else 
        frac_nat0(ngt)  = frac_nat(ngt)
        frac_crop0(ngt) = frac_crop(ngt)
        frac_past0(ngt) = frac_past(ngt)
        frac_urb0(ngt)  = frac_urb(ngt)
        frac_rock0(ngt) = frac_rock(ngt)
        frac_wat0(ngt)  = frac_wat(ngt)
       endif
      endif       
      
      return
      end subroutine read_lu