c=======================================================================
c***********************************************************************
      subroutine record_grid(y,ngt)
c***********************************************************************
c=======================================================================

c=======================================================================
c   This routine records soil water, biomass, soil carbon and leaf area 
c   index in vectors for initialisation at the beginning of the next 
c   year 
c=======================================================================
      implicit none
      
      include './com_18/parameter.common'
      include './com_18/acclim.common'      
      include './com_18/annee.common'
      include './com_18/cmoiRmin.common'
      include './com_18/climin0.common'
      include './com_18/climin.common'            
      include './com_18/cte.common'
      include './com_18/ecoin.common'
      include './com_18/inidata.common'
      include './com_18/nspc.common'
      include './com_18/plant_pool.common'
      include './com_18/prev_yr.common'      
      include './com_18/soil_pool.common'
      include './com_18/frac_change.common'
c-----------------------------------------------
c JLP ajout� pour implicit none
c
      integer ip,ipool,kpool,ngt
c
c-----------------------------------------------      
      double precision y
      dimension y(nequat)
      integer j,m

c=======================================================================
c   records values of water and carbon pools.
c=======================================================================
      do j = 1, nres
       ywat_ini(j,ngt) = y(j)
      end do

      do ip = 1, npft

        do ipool = 1, npool
             ycar_ini(ip,ipool,ngt) = carbon(ip,ipool,nd)
        enddo
        yrese_ini(ip,ngt) = rese(ip)
	ybinc_ini(ip,ngt) = ybinc(ip)
        if((imig.eq.0).or.(imig.eq.1.and.nyr_t.eq.0)) then ! marie
          yfrac_ini(ip,ngt) = frac(ip)
        endif
        if(ip.le.npft0) ylaimin_ini(ip,ngt) = xlai_min(ip)
        if(ip.le.npft0) ylaimax_ini(ip,ngt) = xlai_max(ip)
      enddo
      do kpool = 1, 2
        ylit_ini(kpool,ngt) = xlit(kpool,nd)
      end do
      yhum_ini(ngt) = xhumus(nd)
      
c=======================================================================
c   records monthly temperatures for next year acclimation
c=======================================================================      
      
      do m = 1, nm
       py_mtem(ngt,m)= tcel0(m)
      end do 

      return
      end subroutine record_grid