c=======================================================================
c***********************************************************************
      subroutine write_luc(ngt)
c***********************************************************************
c=======================================================================

c=======================================================================
c   This routine prints carbon emission and litter production fluxes
c   from land use change
c=======================================================================

      implicit none 
           
      include './com_18/parameter.common'
      include './com_18/coord.common'
      include './com_18/cte.common'
      include './com_18/ecoin.common'
      include './com_18/icyr.common'
      include './com_18/inidata.common'                              
      include './com_18/landuse.common'
      include './com_18/landuse0.common'
      include './com_18/luc.common'
      include './com_18/lucflx.common'
      include './com_18/iprt.common'                         
      include './com_18/nspc.common'
      include './com_18/plant_pool.common'
      include './com_18/plant_evol.common'
      include './com_18/soil_pool.common'
      
      integer ip,ipool,ngt
      real*4 tyemi_luc,txlit_luc
      character*100 formatw  

      write(formatw,*)'(f8.3,1x,f8.3,6(1x,f8.5))'      
      if(iprt_lucdfr.eq.1)write(251,formatw)ylongi,ylati,dfr_nat
     &          ,dfr_crop,dfr_past,dfr_urb,dfr_rock,dfr_wat
      
      tyemi_luc = 0.
      txlit_luc = 0.
      do ip = 1, npft
       do ipool = 1, npool
	tyemi_luc = tyemi_luc + yemi_luc(ip,ipool)
	txlit_luc = txlit_luc + xlit_luc(ip,ipool)
       end do
      end do
      
      write(formatw,*)'(f8.3,1x,f8.3,2(1x,f10.3))'
      if (iprt_lucflx.eq.1) write(252,formatw)ylongi,ylati,tyemi_luc
     &          ,txlit_luc
     
      return
      end subroutine write_luc